#!/bin/bash -e -x

source `dirname $0`/env.sh

# Define the universal output directory environment variable
STATIC_LIB_BUILD_OUTPUT_DIR="${BUILD_STATIC_OUTPUT_DIR}/Build/Products"
UNIVERSAL_STATIC_OUTPUT_FOLDER=${STATIC_LIB_BUILD_OUTPUT_DIR}/${CONFIGURATION}-universal

# Remove the universal output directory
rm -rf "${UNIVERSAL_STATIC_OUTPUT_FOLDER}"

# Build Device and Simulator versions
for sdk in iphoneos iphonesimulator; do
	xcodebuild ${VERSION_INFO} \
  			   -scheme TwilioVoice-static \
  			   -project TwilioVoiceClient/TwilioVoiceClient.xcodeproj \
  			   -configuration ${CONFIGURATION} \
  			   -derivedDataPath "${BUILD_STATIC_OUTPUT_DIR}" \
  			   -sdk ${sdk} \
  			   CODE_SIGN_IDENTITY="${IOS_SIGNING_IDENTITY}" \
  			   build
done

# Create the universal output directory
pushd `dirname $0`/..
mkdir -p "${UNIVERSAL_STATIC_OUTPUT_FOLDER}"
mkdir -p "${UNIVERSAL_STATIC_OUTPUT_FOLDER}/include"

lipo -create -output "${UNIVERSAL_STATIC_OUTPUT_FOLDER}/${STATIC_LIBRARY_FILENAME}" \
             "${STATIC_LIB_BUILD_OUTPUT_DIR}/${CONFIGURATION}-iphoneos/${STATIC_LIBRARY_FILENAME}" \
             "${STATIC_LIB_BUILD_OUTPUT_DIR}/${CONFIGURATION}-iphonesimulator/${STATIC_LIBRARY_FILENAME}"

cp ${STATIC_LIB_BUILD_OUTPUT_DIR}/${CONFIGURATION}-iphoneos/*.h ${UNIVERSAL_STATIC_OUTPUT_FOLDER}/include/


# Use the built static library to execute basic linking & tests
if [ ! -z "${CI_TEST_DEVICE_NAME}" ]; then
  xcodebuild ${VERSION_INFO} \
    -scheme TwilioVoiceStaticLibTests \
    -sdk iphoneos \
    -project TwilioVoiceClient/TwilioVoiceClient.xcodeproj \
    -destination "platform=iOS,name=${CI_TEST_DEVICE_NAME}" \
    test
fi

popd
